L = 10e-6;
C = 1000e-6;
rc = 0;
rl = 0;
G = 0;

A1 = [-(G*rc*rl+rl+rc)/(L*(G*rc+1)), -1/(L*(G*rc+1)); 1/(C*(G*rc+1)), -G/(C*(G*rc+1))];
B1 = [1/L, rc/(L*(G*rc+1)); 0, -1/(C*(G*rc+1))];
C1 = [rc/(G*rc+1), 1/(G*rc+1); 1, 0];
D1 = [0, -rc/(G*rc+1); 0, 0];

A2 = [-(G*rc*rl+rl+rc)/(L*(G*rc+1)), -1/(L*(G*rc+1)); 1/(C*(G*rc+1)), -G/(C*(G*rc+1))];
B2 = [0, rc/(L*(G*rc+1)); 0, -1/(C*(G*rc+1))];
C2 = [rc/(G*rc+1), 1/(G*rc+1); 0, 0];
D2 = [0, -rc/(G*rc+1); 0, 0];

# we are done with the parameters, variable names will be reused


# DC Operating point, specify

Vin = 10;
Iout = 2;
D0 = 0.5;

U0 = [Vin; Iout];

# Averaged matrices

A = D0 * A1 + (1 - D0) * A2;
B = D0 * B1 + (1 - D0) * B2;
C = D0 * C1 + (1 - D0) * C2;
D = D0 * D1 + (1 - D0) * D2;


# DC model

X0 = -inv(A) * B * U0;


# Remaining AC model vectors

E = (A1 - A2) * X0 + (B1 - B2) * U0;
F = (C1 - C2) * X0 + (D1 - D2) * U0;

# Expand B and D matrices to cover for d hat

B = [B E];
D = [D F];



# let's use the control package

pkg load control

# form the state space model

converter = ss(A, B, C, D);

# get the transfer functions

Hs = tf(converter)


ts = 'no loss';

figure(1)
bode(Hs(1, 1), logspace(-3, 6, 901))
title(ts)
print(strcat(ts, '-1.pdf'), '-dpdf')

figure(2)
bode(Hs(1, 2), logspace(-3, 6, 901))
title(ts)
print(strcat(ts, '-2.pdf'), '-dpdf')

figure(3)
bode(Hs(1, 3), logspace(-3, 6, 901))
title(ts)
print(strcat(ts, '-3.pdf'), '-dpdf')

