L = 10e-6;
C = 1000e-6;
rc = 0.1;
rl = 0.1;
G = 0;

A1 = [-(G*rc*rl+rl+rc)/(L*(G*rc+1)), -1/(L*(G*rc+1)); 1/(C*(G*rc+1)), -G/(C*(G*rc+1))];
B1 = [1/L, rc/(L*(G*rc+1)); 0, -1/(C*(G*rc+1))];
C1 = [rc/(G*rc+1), 1/(G*rc+1); 1, 0];
D1 = [0, -rc/(G*rc+1); 0, 0];

A2 = [-(G*rc*rl+rl+rc)/(L*(G*rc+1)), -1/(L*(G*rc+1)); 1/(C*(G*rc+1)), -G/(C*(G*rc+1))];
B2 = [0, rc/(L*(G*rc+1)); 0, -1/(C*(G*rc+1))];
C2 = [rc/(G*rc+1), 1/(G*rc+1); 0, 0];
D2 = [0, -rc/(G*rc+1); 0, 0];

# we are done with the parameters, variable names will be reused


# DC Operating point, specify

Vin = 10;
Iout = 2;

U0 = [Vin; Iout];


# Now, we can start loop over D0

n = 101;
D0s = linspace(0, 1, n);

X0s = [];
Y0s = [];

for D0 = D0s
    
    # Averaged matrices

    A = D0 * A1 + (1 - D0) * A2;
    B = D0 * B1 + (1 - D0) * B2;
    C = D0 * C1 + (1 - D0) * C2;
    D = D0 * D1 + (1 - D0) * D2;

    # DC model

    iA = inv(A);
    X0 = -iA * B * U0;
    Y0 = (D - C * iA * B) * U0;
    
    X0s = [X0s, X0];
    Y0s = [Y0s, Y0];
    
endfor

Vouts = Y0s(1, :);

figure(1)
plot(D0s, Vouts)
xlabel('D0')
ylabel('Vout')
title('Vout(D0), rl = 0.1 ohm, rc = 0.1 ohm')
print('Vout-D0.pdf', '-dpdf')

